package com.simuwang.base.common.enums;

import java.util.stream.Stream;

/**
 * FileName: DistributeType
 * Author:   chenjianhua
 * Date:     2024/9/16 13:30
 * Description: ${DESCRIPTION}
 */
public enum YesOrNoType {
    //单位分红/拆分比例
    YES(1, "是"), NO(2, "否");

    private final Integer code;
    private final String info;

    YesOrNoType(Integer code, String info) {
        this.code = code;
        this.info = info;
    }

    public static YesOrNoType getYesOrNoTypeByCode(Integer code) {
        if (null == code){
            return null;
        }
        for(YesOrNoType s : YesOrNoType.values()){
            if(code.equals(s.getCode())){
                return s;
            }
        }
        return null;
    }

    public static YesOrNoType getYesOrNoTypeByInfo(String info) {
        return Stream.of(YesOrNoType.values()).filter(e -> e.info.equals(info)).findFirst().orElse(null);
    }

    public Integer getCode() {
        return code;
    }

    public String getInfo() {
        return info;
    }
}
