package com.simuwang.base.mapper.daq;

import com.simuwang.base.pojo.dos.*;
import com.simuwang.base.pojo.dto.query.DeletionPageQuery;
import com.simuwang.base.pojo.dto.query.FundDeletionPageQuery;
import com.simuwang.base.pojo.vo.FundDeletionInfoVO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * FileName: DeletionInfoMapper
 * Author:   chenjianhua
 * Date:     2024/9/17 18:59
 * Description: ${DESCRIPTION}
 */
@Mapper
public interface DeletionInfoMapper {
    List<DeletionInfoDO> searchDeletionList(DeletionPageQuery deletionPageQuery);

    long countDeletion(DeletionPageQuery deletionPageQuery);

    String getLastDeletionDateByFundId(@Param("fundId") String fundId,@Param("deletionType") Integer deletionType);

    List<FundDeletionInfoDO> searchFundDeletionList(FundDeletionPageQuery fundDeletionPageQuery);

    long countFundDeletionList(FundDeletionPageQuery fundDeletionPageQuery);

    void update(FundDeletionInfoDO infoDO);

    void batchUpdate(@Param("itemDoList") List<FundDeletionInfoDO> fundDeletionInfoDOList);

    void updateRemark(@Param("channelId") Integer channelId,@Param("fundId") String fundId, @Param("deletionType") Integer deletionType,@Param("deletionDate") String deletionDate, @Param("remark")String remark,@Param("updaterId")Integer userId);

    List<FundDeletionInfoDO> selectFundDeletionInfoVOList(@Param("fundId") String fundId,@Param("deletionType") Integer deletionType);

    List<DeletionInfoDO> getDeletionInfoDO(@Param("channelId") Integer channelId,@Param("fundId") String funId,@Param("deletionType")Integer code,@Param("list")List<String> tradeDateList);

    void saveDeletionInfoDO(DeletionInfoDO deletionInfoDO);

    List<EmailDeletionInfoDO> selectDeletionInfoByFundId(@Param("fundIdList")List<String> fundIdList);

    void updateSendStatusByFundId(@Param("fundIdList")List<String> fundIdList);

    void deleteDeletionRemark(@Param("fundId")String fundId, @Param("deletionType")Integer deletionType, @Param("list")List<String> tradeDate);

    void deleteDeletion(@Param("channelId") Integer channelId,@Param("fundId")String fundId, @Param("deletionType")Integer deletionType);

    void updateDeletionInfoDO(DeletionInfoDO oldDeletionDO);

    void batchUpdateDeletionInfoDO(@Param("itemDoList") List<DeletionInfoDO> oldDeletionDOList);

    void batchSaveDeletionInfoDO(@Param("itemDoList")List<DeletionInfoDO> insertDeletionInfoDO);

    void batchUpdateRemark(@Param("itemDoList")List<DeletionInfoDO> batchUpdateDeletionInfoDO);

    int countFundDeletion(@Param("fundId")String fundId);

    List<EmailDeletionInfoDO> selectDeletionDetailByFundId(@Param("fundId")String fundId);

    List<FundDeletionTypeDO> getFundDeletionTypeMapList();

    Integer countChannelFundDeletion(@Param("fundId")String fundId, @Param("deletionType")Integer deletionType, @Param("channelId")Integer channelId, @Param("type")int type);

    String getLastDeletionDate(@Param("fundId")String fundId, @Param("deletionType")Integer deletionType, @Param("channelId")Integer channelId);

    List<EmailDeletionInfoDO> selectNavDeletionInfoByFundId(@Param("fundId")String fundId);

    List<EmailDeletionInfoDO> selectDistributeDeletionInfoByFundId(@Param("fundId")String fundId);

    DistributeDeletionInfoDO getDistributeDeletionInfo(@Param("fundId")String fundId);

    void saveDistributeFirstDeletion(DistributeDeletionInfoDO distributeDeletionInfoDO);

    void updateDistributeDeletionInfoDO(DistributeDeletionInfoDO distributeDeletionInfoDO);

    List<EmailDeletionInfoDO> selectAssetDeletionInfoByFundId(@Param("fundId")String fundId);
}
